//------------------------------------------------------------------------------
//	ŎgU
//		쐬ҁFO㒼C2013/11/27 쐬C(c)O㒼 2013
//------------------------------------------------------------------------------

#include <cmath>
#include "Resonator.hpp"

// RXgN^ɋʂȏ
void Resonator::Initialize(float fr, float bw, float fs)
{
	if (piT_ == 0) piT_ = 3.14159265f/fs;
	Set(fr, bw);
	Clear();
}

// Ũp[^̐ݒ
void Resonator::Set(float fr, float bw)
{
	a1_ = 2.0f*exp(-piT_*bw)*cos(2.0f*piT_*fr);
	a2_ = -exp(-2.0f*piT_*bw);
	b0_ = 1.0f - a1_ - a2_;
}

// UɑΉ鏈̎s
float Resonator::Execute(float xin)
{
	float ym = a1_*yn1_ + a2_*yn2_ + b0_*xin;
	yn2_ = yn1_;	// x̃f[^̈ړ
	yn1_ = ym;		// x̃f[^̈ړ
	return ym;
}

// "/W{g" ̒lɑΉ
float Resonator::piT_ = 0;