//------------------------------------------------------------------------------
//	|iwb_j
//		쐬ҁFO㒼C2014/05/05 쐬C(c)O㒼 2014
//------------------------------------------------------------------------------

#ifndef WINDOW_NMB_HPP
#define WINDOW_NMB_HPP

class Window
{
private:
	const int N_DATA_;
	float* wn;

	// Rs[RXgN^̎gp֎~
	Window(const Window& w);
	// Zq̎gp֎~
	Window& operator=(const Window& w);

public:
	// ֐̎ނ߂񋓑
	enum WinType { Hanning, Hamming, Blackman };

	// RXgN^
	Window(int nWidth, WinType type);

	// fXgN^
	~Window() { delete[] wn; }

	// |̎s
	void Execute(float xIn[], float xOut[])
	{
		for (int n=0; n<N_DATA_; n++)
			xOut[n] = wn[n]*xIn[n];
	}
};

#endif	// WINDOW_NMB_HPP
