//------------------------------------------------------------------------------
//	FFT gčꉹ̃XyNg߂
//		tB^C|ǉ
//
//		쐬ҁFO㒼C2014/05/05 쐬C(c)O㒼 2014
//------------------------------------------------------------------------------

#include <cmath>
#include "Rosenberg.hpp"	// єgp
#include "Resonator.hpp"	// Up
#include "Radiator.hpp"		// ˂̌ʗp
#include "FftReal.hpp"		// FFT
#include "Window.hpp"		// |p

int main()
{
	const int FS = 8000;	// W{g
	const int N_RSN = 3;	// U̐

	// єgIuWFNgC{gF123 Hz
	Rosenberg g(123, FS, 1);

	// Ȕ
	Resonator rs[N_RSN];		// UpIuWFNgz̐錾
	rs[0] = Resonator( 654, 50, FS);	// PtH}g
	rs[1] = Resonator(1060, 55, FS);	// QtH}g
	rs[2] = Resonator(2375, 60, FS);	// RtH}g

	Radiator rd;				// ˂̌ʗpIuWFNg̏

	const int N_DATA = 601;	// W{ꂽ̃f[^
	float sn[N_DATA];			// W{ꂽ

	// ꉹ
	for (int n=0; n<N_DATA; n++)
	{
		float vn = g.Execute();	// єg̔
		for (int k=0; k<N_RSN; k++)
			vn = rs[k].Execute(vn);	// ̌
		sn[n] = rd.Execute(vn);		// ˂̌
	}

	//---------------------------------------------
	//  FFT ɂXyNg͂̌vZ
	//---------------------------------------------
	const int N_FFT = 256;		// FFT ̓_
	FftReal myFft(N_FFT);		// FFT pIuWFNg̏

	float x1[N_FFT];			// FFT ɓnf[^̊i[p
	Complex y1[N_FFT/2+1];		// FFT ̌ʂ̊i[p
	float yOut[N_FFT/2+1];

	const int nStart = 110;	// 擾f[^̐擪

	//	폜ӏ
//	for (int n=0; n<N_FFT; n++)
//		x1[n] = sn[n+nStart];

	//---------------------------------------------
	// ǉ͂
	//---------------------------------------------
	// 
	for (int n=0; n<N_FFT; n++)
		x1[n] = sn[n+nStart] - sn[n-1+nStart];
	// |
	Window myWin(N_FFT, Window::Hamming);
	myWin.Execute(x1, x1);
	//---------------------------------------------
	// ǉ͂܂
	//---------------------------------------------

	myFft.Execute(x1, y1);		// FFT ̎s

	// FFT ̐Βl̂Q߂
	for (int n=0; n<=N_FFT/2; n++)
		 yOut[n] = norm(y1[n]);

	// FFT ̐Βl̍ől߂
	float max = 0;		// őlŐK邽߂Ɏgp
	for (int n=0; n<=N_FFT/2; n++)
		max = fmaxf(yOut[n], max);

	// KꂽXyNg̒l dB Pʂɕϊ
	for (int n=0; n<=N_FFT/2; n++)
		if (yOut[n] > 0)
			yOut[n] = 10.0f*log10f(yOut[n]/max);
		else
			yOut[n] = -100;

	// ʂ^[~i I/O ֏o͂
	const float DF = FS/(float)N_FFT;
	printf("\n   [Hz] ,   [dB]\n");
	for (int n=0; n<=N_FFT/2; n++)
		printf("%8.2F, %8.4f\n", n*DF, yOut[n]);
}
