//------------------------------------------------------------------------------
//	ŎgUiwb_j
//		쐬ҁFO㒼C2013/11/27 쐬C(c)O㒼 2013
//------------------------------------------------------------------------------

#ifndef RESONATOR_HPP
#define RESONATOR_HPP

class Resonator
{
private:
	static float piT_;
	float a1_, a2_, b0_;
	float yn1_, yn2_;

	// RXgN^ɋʂȏ
	void Initialize(float fr, float bw, float fs);

public:
	// UgƑш敝ɑΉ\
	struct FrBw { float fr, bw; };

	// ftHgRXgN^
	Resonator() {}

	// sRXgN^
	Resonator(float fr, float bw, float fs) { Initialize(fr, bw, fs); }

	// sRXgN^i\̎gpj
	Resonator(FrBw fb, float fs) { Initialize(fb.fr, fb.bw, fs); }

	// Ũp[^̐ݒ
	void Set(float fr, float bw);

	// Ũp[^̐ݒi\̎gpj
	void Set(FrBw fb) { Set(fb.fr, fb.bw); }

	// ̒xNA
	void Clear() { yn1_ = 0; yn2_ = 0; }

	// UɑΉ鏈̎s
	float Execute(float xin);
};

#endif	// RESONATOR_HPP
